'use strict';

define(function (require) {
    var TaskViewModel = require('taskViewModel');
    var entityHelper = require('entityHelper');
    var EntityFactory = require('entityFactory');
    require('knockout.validation');

    function ViewModel(context, params) {
        var self = this;
        TaskViewModel.call(self, context);

        self.execute = function () {
            // Get incident data through the context object.
            var incident = context.formData();
            var affectedUser = incident.AffectedUser();

            var isNew = false;
            var templateId = '';
            var userClassToLoad = affectedUser.$ClassId$();
            var entityToLoad = affectedUser.$Id$();

            if (affectedUser) {
                // Since the affected user is based on System.User (see Affected User in Incident Type Projection), get the full user object to be able to access all properties.
                return entityHelper.getClassInstance(isNew,
                    userClassToLoad,
                    templateId,
                    entityToLoad).then(function (userInstance) {
                        var userEntity = EntityFactory.createTrackedFormEntity(userInstance, userInstance.$ClassId$, '', []);
                        if (userEntity.Department) {
                            userEntity.Department('IT');
                            var formData = entityHelper.convertJsonEntityToApiEntity(userEntity);
                            return entityHelper.createOrUpdateProjection(formData).then(function () {
                                alert('Done updating affected user department!');
                            });
                        }
                        alert('User did not have a department property, aborting update of department on affected user.');
                    });
            }

            console.log('No affected user to update department on.');
            return $.Deferred().resolve().promise();
        };
    }

    return ViewModel;
});